/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_l_001.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:36 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: bpo_l_001.c,v $
* Revision 1.2  2002/10/07 09:37:36  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:53  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_l_001.c,v 1.2 2002/10/07 09:37:36 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/bpo_lock.h>
#include <mplib1/bpo_list.h>
#include <include/bpo_list_internal.h>
#include <mplib1/bpo_init.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

bpo_Node_t *
bpo_Init_Node( bpo_Node_t *node, char *name, void *item )
{
    void *seg_base;

    seg_base = Get_SODB_Base( node );
    if ( seg_base == NULL )
	return(NULL);
    /* Initial requirement, name, item & list must be null of in same SODB as Node */
    if (   (name==NULL || Get_SODB_Base( name ) == seg_base )
	&& (item==NULL || Get_SODB_Base( item ) == seg_base )
       )
    {
	node->lno_me = GOFF(seg_base,node);
	node->lno_Succ = 0;
	node->lno_Pred = 0;
	if (name)
	    node->lno_Name = GOFF( seg_base, name );
	else
	    node->lno_Name = 0;
	if (item)
	    node->lno_Item = GOFF( seg_base, item );
	else
	    node->lno_Item = 0;
	node->lno_List = 0;
    }else
    {
	node = NULL;
    }
    return(node);
}

/* -- End of File -- */
