#ifndef MPLIB1_BPO_ALLOC
#define MPLIB1_BPO_ALLOC
/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/mplib1/bpo_alloc.h,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:44 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: bpo_alloc.h,v $
* Revision 1.2  2002/10/07 09:37:44  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:59  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/mplib1/bpo_alloc.h,v 1.2 2002/10/07 09:37:44 mpoole Exp $"

#ifdef CXREF
#include <sys/types.h>
#endif

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    structures
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    function definitions
   ------------------------------------------------------------------ */

extern void *shalloc( const void *hint, size_t size );
extern void shfree( void *ptr );
extern char *bpo_strdup( const void *hint, const char *s1 );
extern off_t bpo_strdup_offset( const void *hint, const char *s1 );

#endif
/* -- End of File -- */
