#ifndef MPLIB1_BUILD_ARGV
#define MPLIB1_BUILD_ARGV
/*
*******************************************************************************
*  Copyright (c) 1997 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/mplib1/build_argv.h,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:44 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: build_argv.h,v $
* Revision 1.2  2002/10/07 09:37:44  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:37:00  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/mplib1/build_argv.h,v 1.2 2002/10/07 09:37:44 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#ifndef MPLIB1_DL_LIST
#include <mplib1/dl_list.h>
#endif

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

struct argv_track
{
dl_Node_t	v_node;
dl_List_t	m_track;
dl_List_t	v_parts;
dl_List_t	f_track;
char		**argv;
int		argc;
};

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

extern struct argv_track *build_argv_track( struct argv_track *argvtp, ... );
extern void free_argv_track( struct argv_track *argvtp );

#endif
/* -- End of File -- */
