/*
*******************************************************************************
*  Copyright (c) 1997 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/test/stop_test.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:28 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: stop_test.c,v $
* Revision 1.2  2002/10/07 09:37:28  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:37:07  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/test/stop_test.c,v 1.2 2002/10/07 09:37:28 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <sys/times.h>
#include <mplib1/stopwatch.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Start of Code
   ------------------------------------------------------------------ */

/* Test the stopwatch code */

int
main( int argc, char *argv[] )
{
    struct stopwatch t1,t2;

    init_stopwatch( &t1 );
    init_stopwatch( &t2 );

    start_stopwatch( &t1 );
    system( "ls -l >/dev/null" );
    stop_stopwatch( &t1 );
    printf( "Elapsed time was %s\n", display_stopwatch( &t1, STOPWATCH_SECS_MICROS ) );
    accrete_stopwatch( &t2, &t1 );
    printf( "accreted time was %s\n", display_stopwatch( &t2, STOPWATCH_SECS_MICROS ) );
    start_stopwatch( &t1 );
    system( "ls -l /etc >/dev/null" );
    stop_stopwatch( &t1 );
    printf( "Elapsed time was %s\n", display_stopwatch( &t1, STOPWATCH_SECS_MICROS ) );
    accrete_stopwatch( &t2, &t1 );
    printf( "accreted time was %s\n", display_stopwatch( &t2, STOPWATCH_SECS_MICROS ) );
    return(0);
}

/* -- End of File -- */
