/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_l_016.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:36 $
*  $Revision: 1.2 $
*
*******************************************************************************
*
* Change History
*
* $Log: bpo_l_016.c,v $
* Revision 1.2  2002/10/07 09:37:36  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:53  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

#ident "$Header: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/bpo_l_016.c,v 1.2 2002/10/07 09:37:36 mpoole Exp $"

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/bpo_lock.h>
#include <mplib1/bpo_list.h>
#include <include/bpo_list_internal.h>
#include <mplib1/bpo_init.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

void
bpo_Walk_List( bpo_List_t *l_ptr,
		bpo_Walk_List_t disp,
		void *param )
{
    bpo_Node_t *n_ptr,*nn_ptr;
    void *seg_base;

    seg_base = Get_SODB_Base( l_ptr );

    bpo_pid_Lock( &l_ptr->lno_Pid_Lock );
    n_ptr = GANNODE( seg_base, l_ptr->lno_Head.lno_Succ );

    while (n_ptr->lno_Succ)
    {
	/* save the next pointer just in case they mash the list */
	nn_ptr = GANNODE( seg_base, n_ptr->lno_Succ);
	(*disp)( GRPTR( n_ptr, n_ptr->lno_Item ), param );
	if (n_ptr == nn_ptr)
	    break;
	n_ptr = nn_ptr;
    };
    bpo_pid_Unlock( &l_ptr->lno_Pid_Lock );
    return;
}

/* -- End of File -- */
