/*
*******************************************************************************
*  Copyright (c) 1996 Martin Poole                            *
*******************************************************************************
**
** WARNING !!  WARNING !! WARNING !! WARNING !! WARNING !! WARNING !!
**
** Any changes to be made to this file should first be checked with
** mplib1 source control for library integrity.
**
** mplib1 source control can be reached at  mplib1@quatermass.co.uk
** 
*                                                                             *
*  $Source: /home/cvs/cvsroot/onelan/onelan/src/mplib1/libsrc/time_2.c,v $
*  $Author: mpoole $
*  $Date: 2002/10/07 09:37:40 $
*  $Revision: 1.2 $
*                                                                             *
*******************************************************************************
*                                                                             *
* $Log: time_2.c,v $
* Revision 1.2  2002/10/07 09:37:40  mpoole
* Initial checkin of mplib1-3.1.0
*
* Revision 1.1  2002/10/07 09:36:57  mpoole
* Initial checkin of mplib1-3.1.0
*
*
*******************************************************************************
*/

/* ------------------------------------------------------------------
    Include files
   ------------------------------------------------------------------ */

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <pwd.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>
#include <memory.h>
#include <malloc.h>

#include <mplib1/mplib1_config.h>
#include <mplib1/fprintfile.h>

/* ------------------------------------------------------------------
    defines
   ------------------------------------------------------------------ */

/* ------------------------------------------------------------------
    Code starts here
   ------------------------------------------------------------------ */

char *
build_timestamp_str( struct timeval *tvp, char *buf )
{
    char hunds[10];
    struct tm *tim;
    if (tvp && buf)
    {
	tim = gmtime((time_t *)&tvp->tv_sec);

/*	strftime( buf, TIMESTAMP_STR_SZ, "%Y/%m/%d %H:%M:%S", tim );*/
/*	sprintf( hunds, ":%02d", (int)(tvp->tv_usec / 10000L) );*/

	/* Change to conform to ISO 8601 / EN 28601 */
	strftime( buf, TIMESTAMP_STR_SZ, "%Y-%m-%d %H:%M:%S", tim );
	sprintf( hunds, ".%02dZ", (int)(tvp->tv_usec / 10000L) );

	strcat( buf, hunds );
    }
    
    return(buf);
}

/* -- End of File -- */
